//+------------------------------------------------------------------+
//|                                                    Reader_EA.mq4 |
//|                                            Copyright  2007, JTA |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, JTA"
#include <stderror.mqh>
#include <stdlib.mqh>

// files have to be placed in expert/files. Archive should also be a folder in expert/files
// trailingstop not implemented yet
// if the symbol in the file is different from the symbol from the chart, nothing happens
// when a trade is opened, some data will be written in a file in the archives-folder
// the EA only buys/sell when the Bid or Ask goes through the price from the file
// it will then try to buy/sell for the price mentioned in the file

//---- input parameters
extern string    FileNameBuy = "buysignal.txt";
extern string    FileNameSell = "sellsignal.txt";
extern string    ArchiveFolderName = "Archive";
extern int       slippage = 3;

double Lots = 0.1;
int    MagicNumber = 240754;
double StopLoss = 30;
double TakeProfit = 30;
double TrailingStop = 20;
string FileSymbol;
double FilePrice;
double OldBidPrice;
double OldAskPrice;
double NewBidPrice;
double NewAskPrice;

bool tradebusy = false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   OldBidPrice = 0;
   NewBidPrice = 0;
   OldAskPrice = 0;
   NewAskPrice = 0;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{  int handle1, handle2, buyticket, selticket;
   string cmtstr, hlp;
   bool buysgnl, selsgnl;
   datetime orderOpen;

   OldBidPrice = NewBidPrice;NewBidPrice = Bid;
   OldAskPrice = NewAskPrice;NewAskPrice = Ask;
   
   buyticket = TicketNumberOfBuy();
   selticket = TicketNumberOfSel();
   tradebusy = false;if (buyticket > 0 || selticket > 0) tradebusy = true;

   if (tradebusy)
   {
      if (buyticket > 0) Comment("\nbusy trading (buy)");
      if (selticket > 0) Comment("\nbusy trading (sell)");
      return(0);
   }
   
   buysgnl = false;selsgnl = false;
   cmtstr = "\nWaiting";
   Comment(cmtstr);

   handle1 = FileOpen(FileNameBuy, FILE_CSV|FILE_READ, ';');
   if (handle1 > 0)
   {
      FileSymbol = FileReadString(handle1);
      hlp = FileReadString(handle1);FilePrice = StrToDouble(hlp);
      hlp = FileReadString(handle1);Lots = StrToDouble(hlp);
      hlp = FileReadString(handle1);TakeProfit = StrToDouble(hlp);
      hlp = FileReadString(handle1);StopLoss = StrToDouble(hlp);
      hlp = FileReadString(handle1);TrailingStop = StrToDouble(hlp);
      Print(FileSymbol, FilePrice, Lots, TakeProfit, StopLoss, TrailingStop); 
      FileClose(handle1);
      if (FileSymbol == Symbol()) buysgnl = true;
      if (OldBidPrice == 0) buysgnl = false;
      if (OldBidPrice < FilePrice && NewBidPrice < FilePrice) buysgnl = false;
      if (OldBidPrice > FilePrice && NewBidPrice > FilePrice) buysgnl = false;
      if (buysgnl) cmtstr = "\nBuySignal: "+DoubleToStr(Lots,1)+" "+FileSymbol+" "+DoubleToStr(FilePrice, Digits);
      handle1 = 0;
   }
   handle2 = FileOpen(FileNameSell, FILE_CSV|FILE_READ, ';');
   if (handle2 > 0)
   {
      FileSymbol = FileReadString(handle2);
      hlp = FileReadString(handle2);FilePrice = StrToDouble(hlp);
      hlp = FileReadString(handle2);Lots = StrToDouble(hlp);
      hlp = FileReadString(handle2);TakeProfit = StrToDouble(hlp);
      hlp = FileReadString(handle2);StopLoss = StrToDouble(hlp);
      hlp = FileReadString(handle2);TrailingStop = StrToDouble(hlp);
      Print(FileSymbol, FilePrice, Lots, TakeProfit, StopLoss, TrailingStop); 
      FileClose(handle2);
      if (FileSymbol == Symbol()) selsgnl = true;
      if (OldAskPrice == 0) selsgnl = false;
      if (OldAskPrice < FilePrice && NewAskPrice < FilePrice) selsgnl = false;
      if (OldAskPrice > FilePrice && NewAskPrice > FilePrice) selsgnl = false;
      if (selsgnl) cmtstr = "\nSellSignal: "+DoubleToStr(Lots,1)+" "+FileSymbol+" "+DoubleToStr(FilePrice, Digits);
      handle2 = 0;
   }

   if (DoNewTrade(buysgnl, selsgnl))
   {
      if (buysgnl)
      {
         FileDelete(FileNameBuy);
         buyticket = TicketNumberOfBuy();
         OrderSelect(buyticket, SELECT_BY_TICKET);
         orderOpen = OrderOpenTime(); 
         handle1 = FileOpen(ArchiveFolderName+"\\"+FileNameBuy, FILE_CSV|FILE_WRITE, ';');
         FileWrite(handle1, TimeToStr(orderOpen), "B", OrderOpenPrice(), OrderMagicNumber(), OrderLots());
         FileFlush(handle1);
         FileClose(handle1);
      }
      if (selsgnl)
      {
         FileDelete(FileNameSell);
         selticket = TicketNumberOfSel();
         OrderSelect(selticket, SELECT_BY_TICKET);
         orderOpen = OrderOpenTime();
         handle2 = FileOpen(ArchiveFolderName+"\\"+FileNameSell, FILE_CSV|FILE_WRITE, ';');
         FileWrite(handle2, TimeToStr(orderOpen), "S", OrderOpenPrice(), OrderMagicNumber(), OrderLots());
         FileFlush(handle2);
         FileClose(handle2);
      }
   }
   
   Comment(cmtstr);
   
   return(0);
}

int TicketNumberOfBuy()
{  int cnt, rs;

   int total = OrdersTotal();
   rs = 0; 
   for (cnt = 0; cnt < total; cnt++)
   {
      if (!OrderSelect(cnt, SELECT_BY_POS))
      {
         Print("Error OrderSelect: ", GetLastError());
         continue;
      }
      if (OrderSymbol() != Symbol()) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderType() == OP_BUY ) rs = OrderTicket();   
   }
   return(rs);
}

int TicketNumberOfSel()
{  int cnt, rs;

   int total = OrdersTotal();
   rs = 0; 
   for (cnt = 0; cnt < total; cnt++)
   {
      if (!OrderSelect(cnt, SELECT_BY_POS))
      {
         Print("Error OrderSelect: ", GetLastError());
         continue;
      }
      if (OrderSymbol() != Symbol()) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderType() == OP_SELL) rs = OrderTicket();   
   }
   return(rs);
}

bool DoNewTrade(bool canbuy, bool cansel)
{  int ticket;
   double slv, tpv;

   slv = StopLoss * Point;
   tpv = TakeProfit * Point;

   if (canbuy) 
   {
      ticket = OrderSend(Symbol(), OP_BUY, Lots, FilePrice, slippage, Bid-slv, Ask+tpv, "Reader_EA_0.9", MagicNumber, 0, Green);
      if(ticket > 0)
      {
         if (OrderSelect(ticket, SELECT_BY_TICKET,MODE_TRADES)) {Print("BUY order opened : ", OrderOpenPrice(), "-", MagicNumber);tradebusy = true;return(true);}
      }
      else Print("Error opening BUY order : ", ErrorDescription(GetLastError())); 
      return(false);
   }
   if (cansel) 
   {
      ticket = OrderSend(Symbol(), OP_SELL, Lots, FilePrice, slippage, Ask+slv, Bid-tpv, "Reader_EA_0.9", MagicNumber, 0, Red);
      if(ticket > 0)
      {
         if (OrderSelect(ticket, SELECT_BY_TICKET,MODE_TRADES)) {Print("SELL order opened : ", OrderOpenPrice(), "-", MagicNumber);tradebusy = true;return(true);}
      }
      else Print("Error opening SELL order : ", ErrorDescription(GetLastError()));
      return(false);
   }
}
//            if(TrailingStopMode && TrailingStop > 0) {                
//               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
//                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
//                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
//                     if (!EachTickMode) BarCount = Bars;
//                     continue;
//                  }
//               }
//            }

//+------------------------------------------------------------------+